// LibraryFuncExtractor.cpp: implementation of the CLibraryFuncExtractor class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "LibraryFuncExtractor.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLibraryFuncExtractor::~CLibraryFuncExtractor()
{
	m_MapStringToPtr.RemoveAll();
}
int CLibraryFuncExtractor::Add(int nCount,LPCTSTR *lpszProcName)
{
	if (!lpszProcName || nCount<=0)
		return 0; // no items got
	int nInserted=0;
	for (int i=0 ; i<nCount ; i++)
		if (AddProc(lpszProcName[i],TRUE))
			nInserted++;
	return nInserted;
}
BOOL CLibraryFuncExtractor::AddProc(LPCTSTR lpszProcName,BOOL bRefreshAddress)
{
	if (!lpszProcName)	return 0; // no items got
	void *pFarProc;
	BOOL bResult = m_MapStringToPtr.Lookup(lpszProcName,pFarProc);
	if (!bRefreshAddress)
		return TRUE; //already inserted : dont refresh
	
	FARPROC farProc = FindProc(lpszProcName);
	if (farProc)
		m_MapStringToPtr.SetAt(lpszProcName,(void*)farProc);
	return (farProc!=NULL);	
}
FARPROC CLibraryFuncExtractor::GetProc(LPCTSTR lpszProcName,BOOL bLookUpIfNotInMap)
{
	void *pFarProc;
	BOOL bResult = m_MapStringToPtr.Lookup(lpszProcName,pFarProc);
	if (bResult && pFarProc!=NULL)
		return (FARPROC)pFarProc;
	
	AddProc(lpszProcName,TRUE); // trying to refresh address
	
	bResult = m_MapStringToPtr.Lookup(lpszProcName,pFarProc);
	if (bResult && pFarProc!=NULL)
		return (FARPROC)pFarProc;
	return NULL; // not found
}


