// LoadLibrary.cpp: implementation of the CLoadLibrary class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "LoadLibrary.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLoadLibrary::CLoadLibrary()
{
	hInstance=NULL;
}

CLoadLibrary::CLoadLibrary(LPCTSTR lpszFileName)
{
	hInstance=NULL;
	Load(lpszFileName,FALSE,FALSE);
}
CLoadLibrary::CLoadLibrary(LPCTSTR lpszFileName,BOOL bSystemDirectory,BOOL bWindowsDirectory)
{
	hInstance=NULL;
	Load(lpszFileName,bSystemDirectory,bWindowsDirectory);
}

BOOL CLoadLibrary::Load(LPCTSTR lpszFileName,BOOL bSystemDirectory,BOOL bWindowsDirectory)
{
	if (!lpszFileName)	return FALSE;//no file name
	CString m_strTitleName=lpszFileName;

	int nPos = m_strTitleName.ReverseFind(_T('.'));
	CString strExtension = m_strTitleName.Mid(nPos);

	// only dlls are loaded (remove line for other files
	if (strExtension.CompareNoCase(_T(".dll")))
		return FALSE;
	Free();

	TCHAR tch[MAX_PATH*2];
	memset(tch,0,sizeof(tch));

	if (!bSystemDirectory && !bWindowsDirectory)
		m_strLibrary=lpszFileName;	
	if (bSystemDirectory)
		::GetSystemDirectory(tch,sizeof(tch)-sizeof(TCHAR));
	else if (bWindowsDirectory)
		::GetWindowsDirectory(tch,sizeof(tch)-sizeof(TCHAR));

	if (bSystemDirectory || bWindowsDirectory) {
		m_strLibrary = (LPCTSTR)tch;
		m_strLibrary += _T("\\");
		m_strLibrary += lpszFileName;
	}

	hInstance=::LoadLibrary(m_strLibrary);
	return hInstance!=NULL;
}

//finding function in a dll
FARPROC CLoadLibrary::FindProc(LPCTSTR lpszProcName)
{
	if (!hInstance || !lpszProcName)
		return NULL;
	if (!m_strLibrary.GetLength())
		return NULL;
	FARPROC farProc=::GetProcAddress(hInstance,lpszProcName);
	return farProc;
}

void CLoadLibrary::Free()
{
	if (!hInstance)
		return;
	::FreeLibrary(hInstance);
	hInstance=NULL;
	m_strLibrary=_T("");
}

CLoadLibrary::~CLoadLibrary()
{
	Free();
}
